// API - Any Device - Linux
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_os_event.h $
// $Rev: 23674 $
// $Date: 2013-10-31 16:25:34 -0500 (Thu, 31 Oct 2013) $

#ifndef __GSC_OS_EVENT_H__
#define __GSC_OS_EVENT_H__

typedef struct _os_event_t		os_event_t;
typedef struct _os_event_node_t	os_event_node_t;

#include <pthread.h>

#include "gsc_os_key.h"
#include "gsc_common.h"
#include "gsc_os_device.h"



/* typedefs	*****************************************************************/

struct _os_event_node_t
{
	pthread_cond_t				cond;	// The condition variable.
	int							count;
	int							trash;	// Set this to abort normal resume.
	const os_event_t**			list;
	struct _os_event_node_t*	prev;
	struct _os_event_node_t*	next;
};

struct _os_event_t
{
	os_key_t		key;	// First field!
	unsigned long	handle;
	char			name[64];
	os_device_t*	device;	// Used to block and resume threads.
};



/* prototypes	*************************************************************/

U32	os_event_create(os_event_t* event, const char* name, os_device_t* device);
U32	os_event_destroy(os_event_t* event);
U32	os_events_release(os_device_t* device);
U32	os_event_t_init(os_event_t* event);
U32	os_event_trigger(os_event_t* event);
U32	os_event_validate(os_event_t* event);
U32	os_event_wait(const os_event_t* event, U32 timeout_ms);
U32	os_event_wait_2(const os_event_t* e1, const os_event_t* e2, U32 timeout_ms);
U32	os_event_wait_multi(const os_event_t* list, U8 count, U32 timeout_ms);



#endif
