// API - Any Device - Linux
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_os_key.h $
// $Rev: 23674 $
// $Date: 2013-10-31 16:25:34 -0500 (Thu, 31 Oct 2013) $

#ifndef __GSC_OS_KEY_H__
#define __GSC_OS_KEY_H__

#include <assert.h>

#include "gsc_common.h"



/* #defines	*****************************************************************/

#define	OS_KEY_MAKE(a,b,c,d)		(GSC_FIELD_ENCODE((a),31,24) |	\
									 GSC_FIELD_ENCODE((b),23,16) |	\
									 GSC_FIELD_ENCODE((c),15, 8) |	\
									 GSC_FIELD_ENCODE((d), 7, 0))
#define	OS_KEY_SET(ptr,key_val)		((ptr)->key.u32 = (key_val))
#define	OS_KEY_VERIFY(ptr,key_val)	assert((ptr)->key.u32 == (key_val))

#define	OS_DEVICE_T_KEY				OS_KEY_MAKE('O', 'd', 'e', 'v')
#define	OS_EVENT_T_KEY				OS_KEY_MAKE('O', 'e', 'v', 'e')
#define	OS_SEM_T_KEY				OS_KEY_MAKE('O', 's', 'e', 'm')
#define	OS_THREAD_T_KEY				OS_KEY_MAKE('O', 't', 'h', 'r')

#define	OS_DEVICE_T_KEY_VERIFY(ptr)	OS_KEY_VERIFY((ptr),OS_DEVICE_T_KEY)
#define	OS_EVENT_T_KEY_VERIFY(ptr)	OS_KEY_VERIFY((ptr),OS_EVENT_T_KEY)
#define	OS_SEM_T_KEY_VERIFY(ptr)	OS_KEY_VERIFY((ptr),OS_SEM_T_KEY)
#define	OS_THREAD_T_KEY_VERIFY(ptr)	OS_KEY_VERIFY((ptr),OS_THREAD_T_KEY)



/* typedefs	*****************************************************************/

typedef union
{
	U32	u32;
	U8	ascii[4];
} os_key_t;



#endif
