// DocSrc - HPDI32 - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/docsrc/hpdi32_dsl.h $
// $Rev: 23672 $
// $Date: 2013-10-31 16:23:58 -0500 (Thu, 31 Oct 2013) $

/*
*	Provide an external interface to the HPDI32 driver's documentation
*	sample code.
*/

#ifndef __HPDI32_DSL_H__
#define __HPDI32_DSL_H__

#include "hpdi32_api.h"

#ifdef __cplusplus
extern "C" {
#endif



/* prototypes	**************************************************************/

U32		hpdi32_dsl_api_status(int verbose);
U32		hpdi32_dsl_board_count(U8* count, int verbose);
U32		hpdi32_dsl_close(void* handle, int verbose);
U32		hpdi32_dsl_gpio_0_mod(void* handle, U8 value, int verbose);
U32		hpdi32_dsl_gpio_read(void* handle, U8* value, int verbose);
U32		hpdi32_dsl_gpio_write(void* handle, U8 value, int verbose);
U32		hpdi32_dsl_init(void* handle, int verbose);
long	hpdi32_dsl_io_status_evaluate(U32 io_status);
U32		hpdi32_dsl_io_tx_timeout_get(void* handle, unsigned long* timeout_secs, int verbose);
U32		hpdi32_dsl_io_tx_timeout_reset(void* handle, int verbose);
U32		hpdi32_dsl_io_tx_timeout_set(void* handle, U32 timeout_s, int verbose);
U32		hpdi32_dsl_io_tx_wait(void* handle, U32 timeout_ms, int verbose);
U32		hpdi32_dsl_irq_fifo_full_wait(void* handle, U32 timeout_ms, int verbose);
U32		hpdi32_dsl_open(U8 index, void** handle, int verbose);
U32		hpdi32_dsl_read(void* handle, void* buffer, U32 bytes, U32* count, int verbose);
U32		hpdi32_dsl_reg_bcr_mod(void* handle, U32 value, U32 mask, int verbose);
U32		hpdi32_dsl_reg_bcr_read(void* handle, U32* value, int verbose);
U32		hpdi32_dsl_reg_bcr_write(void* handle, U32 value, int verbose);
U32		hpdi32_dsl_reset(void* handle, int verbose);
U32		hpdi32_dsl_status_text(U32 stat, int verbose);
U32		hpdi32_dsl_version_get(void* handle, U8 id, int verbose);
U32		hpdi32_dsl_write(void* handle, const void* buffer, U32 bytes, U32* count, int verbose);



#ifdef __cplusplus
}
#endif

#endif
