#include "hpdi32_dsl.h"

#include <stdio.h>

U32 hpdi32_dsl_io_tx_timeout_get(
	void*			handle,
	unsigned long*	timeout_secs,
	int				verbose)
{
	U32	status;

	// Retrieve the Tx I/O timeout period without changing it.
	status	= hpdi32_config(handle,
							HPDI32_IO_TIMEOUT,
							HPDI32_WHICH_TX,
							GSC_NO_CHANGE,
							timeout_secs);

	if (!verbose)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		printf("hpdi32_config() failure: %ld\n", (long) status);
	}
	else
	{
		printf("Tx Timeout: %lu seconds\n", (long) timeout_secs[0]);
	}

	return(status);
}
