#include "hpdi32_dsl.h"

#include <stdio.h>

U32	hpdi32_dsl_io_tx_timeout_set(
	void*	handle,
	U32		timeout_s,
	int		verbose)
{
	unsigned long	get;
	U32				status;

	status	= hpdi32_config(handle,
							HPDI32_IO_TIMEOUT,
							HPDI32_WHICH_TX,
							timeout_s,
							&get);

	if (!verbose)
	{
	}
	else if (status != GSC_SUCCESS)
	{
		printf("hpdi32_config() failure: %ld\n", (long) status);
	}
	else
	{
		printf("Tx Timeout:\n");
		printf("  Set: 0x%lX\n", (long) timeout_s);
		printf("  Get: 0x%lX\n", (long) get);
	}

	return(status);
}
