// This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL).
// Any Device - Driver - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/driver/gsc_types.h $
// $Rev: 23671 $
// $Date: 2013-10-31 16:23:27 -0500 (Thu, 31 Oct 2013) $

#ifndef __GSC_TYPES_H__
#define __GSC_TYPES_H__



#if (defined(WIN32) || defined(_WIN32) || defined(_WIN64))

	#include <windows.h>

	#define	GSC_EXPORT		WINAPI

	#ifndef GSC_DATA_TYPES_NOT_NEEDED

		typedef signed char		S8;
		typedef unsigned char	U8;
		typedef signed short	S16;
		typedef unsigned short	U16;
		typedef signed long		S32;
		typedef unsigned long	U32;

	#endif

	typedef	U32		OS_USR_ADDR_T;

#elif defined(__linux__)

	#include <stddef.h>
	#include <asm/types.h>

	#define	GSC_EXPORT

	#ifndef GSC_DATA_TYPES_NOT_NEEDED

		typedef __s8	S8;
		typedef __u8	U8;
		typedef __s16	S16;
		typedef __u16	U16;
		typedef __s32	S32;
		typedef __u32	U32;

	#endif

	typedef	unsigned long	OS_USR_ADDR_T;

#else

	#error OS IS UNDEFINED.

#endif



#endif
