// Utils - HPDI32 - Any OS
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/hpdi32_utils.h $
// $Rev: 23665 $
// $Date: 2013-10-31 16:20:26 -0500 (Thu, 31 Oct 2013) $

#ifndef __HPDI32_UTILS_H__
#define __HPDI32_UTILS_H__

#include "hpdi32_api.h"

#include <stdio.h>



// data types *****************************************************************

typedef struct
{
	void*	buffer;	// Data goes here.
	size_t	size;	// This is the size of the buffer in bytes.
	size_t	offset;	// This is where the data begins.
	U32		count;	// This is the number of bytes of data available beginning at offset.
	int		eof;	// We've reached the end of the data.
} buf_man_t;



// prototypes *****************************************************************

int			dev_api_status(void);

int			dev_board_count(void);

int			dev_cable_command_mode_0(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_1(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_2(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_3(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_4(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_5(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_cable_command_mode_6(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_close(int index, void* dev);

int			dev_favor_tx(void* dev, int index, int verbose, unsigned long set, unsigned long* get);

int			dev_init(void* dev, int index, int verbose);

int			dev_open(U8 index, void** dev);

int			dev_reg_mod(void* dev, U32 reg, U32 value,U32 mask, int verbose);
int			dev_reg_read(void* dev, U32 reg, U32* value, int verbose);
int			dev_reg_write(void* dev, U32 reg, U32 value, int verbose);

int			dev_rx_auto_start(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_enable(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_fifo_ae_level(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_fifo_af_level(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_buffer_pointer(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_buffer_size(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_data_size(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_dma_channel_sel(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_dma_control_mode(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_dma_priority(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_mode(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_overlap_enable(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_pio_threshold(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_single_cycle(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_io_timeout(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_rx_overrun(void* dev, int index, int verbose, unsigned long set, unsigned long* get);

int			dev_tx_auto_start(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_auto_stop(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_clock_divider(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_enable(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_fifo_ae_level(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_fifo_af_level(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_buffer_pointer(void* dev, int index, int verbose, void** get);
int			dev_tx_io_buffer_size(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_data_size(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_dma_channel_sel(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_dma_control_mode(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_dma_priority(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_mode(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_overlap_enable(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_pio_threshold(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_single_cycle(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_io_timeout(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_line_valid_off_count(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_line_valid_on_count(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_remote_throttle(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_rx_tri_state(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_status_valid_count(void* dev, int index, int verbose, unsigned long set, unsigned long* get);
int			dev_tx_status_valid_mirror(void* dev, int index, int verbose, unsigned long set, unsigned long* get);

FILE*		file_close(const char* name, FILE* file);
FILE*		file_create(const char* name);
int			file_eof(const char* name, FILE* file, int* eof);
FILE*		file_open(const char* name);
long		file_read(const char* name, FILE* file, char* buf, size_t size);
long		file_read_line(const char* name, FILE* file, char* dst, size_t size);
int			file_seek(const char* name, FILE* file, long pos);
long		file_tell(const char* name, FILE* file);
long		file_size(const char* name, FILE* file);
long		file_write(const char* name, FILE* file, const char* buf, size_t size);

void		format_float(float value, int k, char* dest, size_t size);
void		format_float_prec(float value, int k, char* dest, size_t size);
void		format_long(long value, int k, char* dest, size_t size);
void		format_s32(S32 value, int k, char* dest, size_t size);
void		format_time_ms(long ms, char* dest, size_t size);
void		format_time_sec(long sec, char* dest, size_t size);

int			host_issue_os(void);

int			id_features(void* dev);
int			id_hardware(void* dev, int index);
int			id_host(void);
int			id_software(void* dev, const char* app_ver);
long long	id_total_mem_silent(void);
int			ini_bool_get(const char* file, const char* section, const char* key, int* value, int defalt);
void		ini_bool_set(const char* file, const char* section, const char* key, int value);
void		ini_init(const char* base_name);
int			ini_int_get(const char* file, const char* section, const char* key, int* value, int defalt);
void		ini_int_set(const char* file, const char* section, const char* key, int value);
int			ini_str_get(const char* file, const char* section, const char* key, char* value, size_t size);
void		ini_str_set(const char* file, const char* section, const char* key, const char* value);
int			ini_u32_get(const char* file, const char* section, const char* key, U32* value, U32 defalt);
void		ini_u32_set(const char* file, const char* section, const char* key, U32 value);

void		label_text(const char* label);
void		label_text_index(const char* label, int index);
int			label_fail_func(int verbose, const char* func, U32 status);
int			label_fail_text(int verbose, const char* text);
int			label_fail_value(int verbose, long value);
void		label_init(int width);
void		label_level_dec(void);
void		label_level_inc(void);
void		label_long_comma(long long value);

int			operation_issues(void* handle, long* tx_size, long* rx_size);

int			reg_list(void* dev, int pci, int plx, int gsc);
const char*	reg_name(U32 reg);

int			select_1_board(int qty, int* index);
int			select_2_boards(int qty, int* index_1, int* index_2);
void		sleep_ms(long ms);
int			stricmp(const char* str1, const char* str2);

U32			time_ms_get_run(void);



#endif
